/* vim:set et sw=2 cin cino=t0,f0,(0,{s,>2s,n-s,^-s,e2s: */

/*
 * Copyright © 2015 Robert Bosch Car Multimedia GmbH
 *
 * SPDX-License-Identifier: MPL-2.0
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include "prestwood-internal.h"
#include "canterbury.h"
#include <stdio.h>
#include <stdlib.h>
#include <dbus/dbus-glib.h>
#include <glib.h>

static void prestwood_cleanup (void)
{
}

static void prestwood_exit (gint status)
{
	exit (status);
}

static void prestwood_handle_exit (void)
{
	struct sigaction action;
	action.sa_handler = prestwood_exit;
	action.sa_flags = 0;
	sigaction (SIGINT, &action, NULL);
	sigaction (SIGHUP, &action, NULL);
	sigaction (SIGTERM, &action, NULL);
	atexit (prestwood_cleanup);
}

static void prestwood_initialize (void)
{
	if (prestwood_init () != 0)
		prestwood_exit (-1);
}


gint main (gint argc, gchar **argv)
{

	prestwood_handle_exit();
	GMainLoop *mainloop = g_main_loop_new (NULL, TRUE);
	if (mainloop == NULL)
		return -1;

	prestwood_initialize ();
	g_timeout_add (0, (GSourceFunc) prestwood_network_connected, NULL);

	mainloop = g_main_loop_new (NULL, FALSE);
	g_main_loop_run (mainloop);
	g_bus_unown_name(prestwood_get_default()->owner_id);


	return 0;
}

